"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    classIntersection: ()=>classIntersection,
    checkClass: ()=>checkClass
});
const _objectKindsTs = require("../../utils/objectKinds.js");
const _composeTs = require("../compose.js");
const classIntersection = (0, _composeTs.composeIntersection)((l, r, state)=>{
    const lClass = typeof l === "string" ? _objectKindsTs.defaultObjectKinds[l] : l;
    const rClass = typeof r === "string" ? _objectKindsTs.defaultObjectKinds[r] : r;
    return lClass === rClass ? (0, _composeTs.equality)() : lClass instanceof rClass ? l : rClass instanceof lClass ? r : state.addDisjoint("class", l, r);
});
const checkClass = (expectedClass, state)=>{
    if (typeof expectedClass === "string") {
        return (0, _objectKindsTs.objectKindOf)(state.data) === expectedClass || !state.problems.add("class", expectedClass);
    }
    return state.data instanceof expectedClass || !state.problems.add("class", expectedClass);
};
