"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "parseNarrowTuple", {
    enumerable: true,
    get: ()=>parseNarrowTuple
});
const _nodeTs = require("../../nodes/node.js");
const _definitionTs = require("../definition.js");
const _distributableFunctionTs = require("./distributableFunction.js");
const parseNarrowTuple = (def, ctx)=>{
    const inputNode = (0, _definitionTs.parseDefinition)(def[0], ctx);
    const resolution = ctx.type.scope.resolveNode(inputNode);
    const hasConfig = (0, _nodeTs.isConfigNode)(resolution);
    const typeNode = hasConfig ? resolution.node : resolution;
    const result = (0, _nodeTs.rootIntersection)(inputNode, (0, _distributableFunctionTs.distributeFunctionToNode)(def[2], typeNode, ctx, "narrow"), ctx.type);
    return hasConfig ? {
        config: resolution.config,
        node: result
    } : result;
};
