"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "parseRecord", {
    enumerable: true,
    get: ()=>parseRecord
});
const _definitionTs = require("./definition.js");
const _scannerTs = require("./string/shift/scanner.js");
const parseRecord = (def, ctx)=>{
    const props = {};
    for(const definitionKey in def){
        let keyName = definitionKey;
        let isOptional = false;
        if (definitionKey[definitionKey.length - 1] === "?") {
            if (definitionKey[definitionKey.length - 2] === _scannerTs.Scanner.escapeToken) {
                keyName = `${definitionKey.slice(0, -2)}?`;
            } else {
                keyName = definitionKey.slice(0, -1);
                isOptional = true;
            }
        }
        ctx.path.push(keyName);
        const propNode = (0, _definitionTs.parseDefinition)(def[definitionKey], ctx);
        ctx.path.pop();
        props[keyName] = isOptional ? [
            "?",
            propNode
        ] : propNode;
    }
    return {
        object: {
            props
        }
    };
};
