"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    parseOperator: ()=>parseOperator,
    writeUnexpectedCharacterMessage: ()=>writeUnexpectedCharacterMessage,
    incompleteArrayTokenMessage: ()=>incompleteArrayTokenMessage
});
const _errorsTs = require("../../../../utils/errors.js");
const _genericsTs = require("../../../../utils/generics.js");
const _scannerTs = require("../scanner.js");
const _boundsTs = require("./bounds.js");
const _divisorTs = require("./divisor.js");
const parseOperator = (s)=>{
    const lookahead = s.scanner.shift();
    return lookahead === "" ? s.finalize() : lookahead === "[" ? s.scanner.shift() === "]" ? s.rootToArray() : s.error(incompleteArrayTokenMessage) : (0, _genericsTs.isKeyOf)(lookahead, _scannerTs.Scanner.branchTokens) ? s.pushRootToBranch(lookahead) : lookahead === ")" ? s.finalizeGroup() : (0, _genericsTs.isKeyOf)(lookahead, _scannerTs.Scanner.comparatorStartChars) ? (0, _boundsTs.parseBound)(s, lookahead) : lookahead === "%" ? (0, _divisorTs.parseDivisor)(s) : lookahead === " " ? parseOperator(s) : /* c8 ignore next */ (0, _errorsTs.throwInternalError)(writeUnexpectedCharacterMessage(lookahead));
};
const writeUnexpectedCharacterMessage = (char)=>`Unexpected character '${char}'`;
const incompleteArrayTokenMessage = `Missing expected ']'`;
