"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    parseString: ()=>parseString,
    maybeNaiveParse: ()=>maybeNaiveParse,
    fullStringParse: ()=>fullStringParse
});
const _nodeTs = require("../../nodes/node.js");
const _dynamicTs = require("./reduce/dynamic.js");
const _operandTs = require("./shift/operand/operand.js");
const _operatorTs = require("./shift/operator/operator.js");
const parseString = (def, ctx)=>ctx.type.scope.parseCache.get(def) ?? ctx.type.scope.parseCache.set(def, maybeNaiveParse(def, ctx) ?? fullStringParse(def, ctx));
const maybeNaiveParse = (def, ctx)=>{
    if (ctx.type.scope.addParsedReferenceIfResolvable(def, ctx)) {
        return def;
    }
    if (def.endsWith("[]")) {
        const elementDef = def.slice(0, -2);
        if (ctx.type.scope.addParsedReferenceIfResolvable(def, ctx)) {
            return (0, _nodeTs.toArrayNode)(elementDef);
        }
    }
};
const fullStringParse = (def, ctx)=>{
    const s = new _dynamicTs.DynamicState(def, ctx);
    (0, _operandTs.parseOperand)(s);
    return loop(s);
};
const loop = (s)=>{
    while(!s.scanner.finalized){
        next(s);
    }
    return s.ejectFinalizedRoot();
};
const next = (s)=>s.hasRoot() ? (0, _operatorTs.parseOperator)(s) : (0, _operandTs.parseOperand)(s);
