"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    arkscope: ()=>arkscope,
    ark: ()=>ark,
    scopes: ()=>scopes,
    spaces: ()=>spaces,
    type: ()=>type
});
const _jsObjectsTs = require("./jsObjects.js");
const _scopeTs = require("./scope.js");
const _tsKeywordsTs = require("./tsKeywords.js");
const _validationTs = require("./validation/validation.js");
const arkscope = (0, _scopeTs.scope)({}, {
    name: "standard",
    includes: [
        _tsKeywordsTs.tsKeywords,
        _jsObjectsTs.jsObjects,
        _validationTs.validation
    ],
    standard: false
});
const ark = arkscope.compile();
const scopes = {
    root: _scopeTs.rootScope,
    tsKeywords: _tsKeywordsTs.tsKeywordsScope,
    jsObjects: _jsObjectsTs.jsObjectsScope,
    validation: _validationTs.validationScope,
    ark: arkscope
};
const spaces = {
    tsKeywords: _tsKeywordsTs.tsKeywords,
    jsObjects: _jsObjectsTs.jsObjects,
    validation: _validationTs.validation,
    ark
};
const type = arkscope.type;
