"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    Cache: ()=>Cache,
    FreezingCache: ()=>FreezingCache
});
const _freezeTs = require("../utils/freeze.js");
class Cache {
    get root() {
        return this.cache;
    }
    has(name) {
        return name in this.cache;
    }
    get(name) {
        return this.cache[name];
    }
    set(name, item) {
        this.cache[name] = item;
        return item;
    }
    constructor(){
        this.cache = {};
    }
}
class FreezingCache extends Cache {
    set(name, item) {
        this.cache[name] = (0, _freezeTs.deepFreeze)(item);
        return item;
    }
}
