"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    initializeType: ()=>initializeType,
    isType: ()=>isType,
    isCheckResult: ()=>isCheckResult,
    isAnonymousName: ()=>isAnonymousName
});
const _traverseTs = require("../traverse/traverse.js");
const _chainableNoOpProxyTs = require("../utils/chainableNoOpProxy.js");
const _genericsTs = require("../utils/generics.js");
const initializeType = (name, definition, config, scope)=>{
    const namedTraverse = (0, _genericsTs.composeNamed)((data)=>{
        const state = new _traverseTs.TraversalState(data, t);
        (0, _traverseTs.traverse)(t.flat, state);
        return state.problems.count ? {
            problems: state.problems
        } : {
            data: state.data
        };
    }, name);
    const root = {
        // temporarily initialize node/flat to aliases that will be included in
        // the final type in case of cyclic resolutions
        node: name,
        flat: [
            [
                "alias",
                name
            ]
        ],
        allows: (data)=>!namedTraverse(data).problems,
        infer: _chainableNoOpProxyTs.chainableNoOpProxy,
        qualifiedName: isAnonymousName(name) ? scope.getAnonymousQualifiedName(name) : `${scope.name}.${name}`,
        definition,
        scope,
        includesMorph: false,
        config
    };
    const t = Object.assign(namedTraverse, root);
    return t;
};
const isType = (value)=>value?.infer === _chainableNoOpProxyTs.chainableNoOpProxy;
const isCheckResult = (value)=>(0, _genericsTs.getNominalId)(value) !== undefined;
const isAnonymousName = (name)=>name[0] === "λ";
