"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    sizeOf: ()=>sizeOf,
    unitsOf: ()=>unitsOf,
    DataWrapper: ()=>DataWrapper
});
const _domainsTs = require("./domains.js");
const _serializeTs = require("./serialize.js");
const sizeOf = (data)=>typeof data === "string" || Array.isArray(data) ? data.length : typeof data === "number" ? data : 0;
const unitsOf = (data)=>typeof data === "string" ? "characters" : Array.isArray(data) ? "items long" : "";
class DataWrapper {
    toString() {
        return (0, _serializeTs.stringify)(this.value);
    }
    get domain() {
        return (0, _domainsTs.domainOf)(this.value);
    }
    get size() {
        return sizeOf(this.value);
    }
    get units() {
        return unitsOf(this.value);
    }
    get className() {
        return Object(this.value).constructor.name;
    }
    constructor(value){
        this.value = value;
    }
}
