import { defaultObjectKinds, objectKindOf } from "../../utils/objectKinds.js";
import { composeIntersection, equality } from "../compose.js";
export const classIntersection = composeIntersection((l, r, state)=>{
    const lClass = typeof l === "string" ? defaultObjectKinds[l] : l;
    const rClass = typeof r === "string" ? defaultObjectKinds[r] : r;
    return lClass === rClass ? equality() : lClass instanceof rClass ? l : rClass instanceof lClass ? r : state.addDisjoint("class", l, r);
});
export const checkClass = (expectedClass, state)=>{
    if (typeof expectedClass === "string") {
        return objectKindOf(state.data) === expectedClass || !state.problems.add("class", expectedClass);
    }
    return state.data instanceof expectedClass || !state.problems.add("class", expectedClass);
};
