import { jsObjects, jsObjectsScope } from "./jsObjects.js";
import { rootScope, scope } from "./scope.js";
import { tsKeywords, tsKeywordsScope } from "./tsKeywords.js";
import { validation, validationScope } from "./validation/validation.js";
export const arkscope = scope({}, {
    name: "standard",
    includes: [
        tsKeywords,
        jsObjects,
        validation
    ],
    standard: false
});
export const ark = arkscope.compile();
export const scopes = {
    root: rootScope,
    tsKeywords: tsKeywordsScope,
    jsObjects: jsObjectsScope,
    validation: validationScope,
    ark: arkscope
};
export const spaces = {
    tsKeywords,
    jsObjects,
    validation,
    ark
};
export const type = arkscope.type;
