import { TraversalState, traverse } from "../traverse/traverse.js";
import { chainableNoOpProxy } from "../utils/chainableNoOpProxy.js";
import { composeNamed, getNominalId } from "../utils/generics.js";
export const initializeType = (name, definition, config, scope)=>{
    const namedTraverse = composeNamed((data)=>{
        const state = new TraversalState(data, t);
        traverse(t.flat, state);
        return state.problems.count ? {
            problems: state.problems
        } : {
            data: state.data
        };
    }, name);
    const root = {
        // temporarily initialize node/flat to aliases that will be included in
        // the final type in case of cyclic resolutions
        node: name,
        flat: [
            [
                "alias",
                name
            ]
        ],
        allows: (data)=>!namedTraverse(data).problems,
        infer: chainableNoOpProxy,
        qualifiedName: isAnonymousName(name) ? scope.getAnonymousQualifiedName(name) : `${scope.name}.${name}`,
        definition,
        scope,
        includesMorph: false,
        config
    };
    const t = Object.assign(namedTraverse, root);
    return t;
};
export const isType = (value)=>value?.infer === chainableNoOpProxy;
export const isCheckResult = (value)=>getNominalId(value) !== undefined;
export const isAnonymousName = (name)=>name[0] === "λ";
